# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://find-sec-bugs.github.io/bugs.htm
# yamllint enable
---
rules:
  - id: "kotlin_crypto_rule-RsaNoPadding"
    languages:
      - "kotlin"
    message: |
      The software uses the RSA algorithm but does not incorporate Optimal Asymmetric
      Encryption Padding (OAEP), which might weaken the encryption.
    metadata:
      shortDescription: "Use of RSA algorithm without OAEP"
      category: "security"
      cwe: "CWE-780"
      owasp:
        - "A3:2017-Sensitive Data Exposure"
        - "A02:2021-Cryptographic Failures"
      security-severity: "MEDIUM"
    severity: "WARNING"

    pattern-either:
      - patterns:
          - pattern: |
              $VAR = "$ALG";
              ...
              javax.crypto.Cipher.getInstance($VAR);
          - metavariable-regex:
              metavariable: "$ALG"
              regex: ".*RSA.*NoPadding.*"
      - patterns:
          - pattern: "javax.crypto.Cipher.getInstance($ALG,...);"
          - metavariable-regex:
              metavariable: "$ALG"
              regex: ".*RSA.*NoPadding.*"
